#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);



    vector<int> presek;
    vector<int> pomocni;
    vector<int> niz;
     int n,q;
     int pom,prvi;
     int brojac = 0;
    cin >> n;
    cin >> prvi;
    pomocni.push_back(0);
    presek.push_back(0);
    niz.push_back(prvi);
    for(int i = 1; i < n; i++){
        cin >>pom;
        niz.push_back(pom);
        if(pom < prvi || flag){
            brojac++;
            presek.push_back(i);
        }
        prvi = pom;
        pomocni.push_back(brojac);
    }
    cin >> q;
    for(int i = 0 ; i < q; i ++){
        cin>>prvi;
        cin>>pom;
        pom--;
        prvi--;
        int k = pomocni[pom];
        if(pomocni[pom] - pomocni[prvi] > 1){
            cout << "NE"<<endl;
            continue;
        }
        if (prvi < presek[k]-1 && presek[k]<pom){
            if (niz[pom] < niz[prvi]){
                cout << "NE"<<endl;
                continue;
            }
        }

            cout << "DA"<<endl;

    }

    return 0;
}